import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.util.List;

/**
 * Write a description of class Cliffs here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Cliffs extends World
{
    private List<Platform> thePlatforms = new ArrayList<Platform>();
    private int[][] coords = {
            {10,530}, {40,530}, {70, 530}, {100,530}, {130,530}, {160,530},
            {100, 465}, {130, 465}, {160, 465}, {190, 465}, {210, 465},
            {390, 400}, {360, 400}, {330, 400}, {300, 400}, {270, 400},
            {60, 370}, {90, 370}, {120, 370}, {150, 370},
            {260, 300}, {290, 300}, {320, 300},
            {130, 250}, {160, 250}, {190, 250},
            {260, 210}, {290, 210}, {320, 210},            
            {10, 170}, {40, 170}, {70, 170}, {100, 170},
            {130, 100}, {160, 100}, {190, 100},            
            {10, 40}, {40, 40}, {70, 40}, {100, 40},           
            {300, -10}, {330, -10}, {360, -10}, {390, -10},           
            {150, -60}, {180, -60}, {210, -60},            
            {10, -120}, {40, -120}, {70, -120}, {100, -120},           
            {310, -130}, {340, -130}, {370, -130}, {390, -130},       
            {180, -180}, {210, -180}, {240, -180},            
            {10, -250}, {40, -250}, {70, -250}, {90, -250},       
            {220, -320}, {250, -320}, {280, -320}, {310, -320},            
            {10,-390}, {40,-390}, {70, -390}, {100,-390}, {130,-390}, {160,-390},
            {100, -470}, {130, -470}, {160, -470}, {190, -470}, {210, -470},
            {390, -550}, {360, -550}, {330, -550}, {300, -550}, {270, -550},
            {60, -610}, {90, -610}, {120, -610}, {150, -610},
            {260, -680}, {290, -680}, {320, -680},
            {130, -750}, {160, -750}, {190, -750},
            {10, -820}, {30, -820}, {60, -820},            
            {260, -820}, {290, -820}, {320, -820},            
            {10, -900}, {40, -900}, {70, -900}, {100, -900},
            {220, -940}, {250, -940}, {280, -940}, {310, -940},            
        };

    /**
     * Constructor for objects of class Cliffs.
     * 
     */
    JetPackGuy theGuy;
    //diags theDiags;
    public Cliffs()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.

        super(400, 600, 1);
        theGuy = new JetPackGuy();
        //theDiags = new diags();
        addObject(theGuy, 200, 70);
        //addObject(theDiags, 200, 20);

        prepare();
    }

    public JetPackGuy getGuy(){
        return theGuy;
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        for(int i=0;i<coords.length;i++)
        {
            thePlatforms.add(new Platform());
            if(coords[i][0]>0 && coords[i][0]<getWidth() && coords[i][1]>0 && coords[i][1] < getHeight())
            {
                addObject(thePlatforms.get(i), coords[i][0], coords[i][1]);
            }

        }

    }

    public void moveWorld(int amount)
    {
        for(int i=0;i<coords.length;i++)
        {
            coords[i][1]=coords[i][1]+ amount;
            Actor thisPlatform = thePlatforms.get(i);
            if(coords[i][0]>0 && coords[i][0]<getWidth() && coords[i][1]>0 && coords[i][1] < getHeight())
            {
                
                if(thisPlatform.getWorld()==null)
                {
                    addObject(thisPlatform, coords[i][0], coords[i][1]);
                } else {
                    thisPlatform.setLocation( coords[i][0], coords[i][1]);
                }
            } else if(thisPlatform.getWorld()!=null)
            {
                removeObject(thisPlatform);
            }

        }

    }
}
